/**
*/

import java.util.*;

import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;

/**
*/
public class 
SessionManager extends UnicastRemoteObject
        implements SessionManagerInterface
{

   boolean DEBUG = true;
   Hashtable  sessionTable = new Hashtable();
   int        sessionCount=0;


   /**
   */
   public
   SessionManager() throws java.rmi.RemoteException 
   {
      sessionCount=0;

   }// end of constructor()

   /**
   */
   public SessionInfo[]
   getListOfSessions()
   {
      Session spec;
      int size = sessionTable.size();
      SessionInfo ret[] = new SessionInfo[size];

      Enumeration e = sessionTable.elements();
      int i=0;
     
      for(;e.hasMoreElements() ;) 
      {
        spec = (Session) e.nextElement();

        if(spec!=null) 
         try { ret[i] = spec.getSessionInfo(); i++; }
         catch(java.rmi.RemoteException re) {}

      }// end of for

      if(DEBUG)
      {
          System.out.println(" There are "+i+" Sessions!"  );
      }
      SessionInfo ret1[] = new SessionInfo[i];

      for(int j=0;j<i;j++) ret1[j]=ret[j];

      return ret1;

   }// end of getListOfSessions()

   /**
   */
   public void
   postInvitation(NetPlayerInterface aPlayer) throws java.rmi.RemoteException
   {

      sessionCount++;
      Session aSession = new Session(aPlayer,sessionCount);
      String key = String.valueOf(sessionCount);
      sessionTable.put(key,aSession);

      // broadcast to everybody

      if(DEBUG)
      {
          System.out.println(" in postInvitation() ");
          System.out.print(" Session "+sessionCount+" is created for ");
          System.out.println(aPlayer.getName());
      }

   }// end of postInvitation() 

   /**
   * returns null : if the session is not found
   *         id of the player (sessionId+"B") since the second player
   *         should be Black. ( I know it is a restriction )
   */
   public String
   joinSession(NetPlayerInterface aPlayer, int sessionId) 
             throws java.rmi.RemoteException
   {
      String ret = null;
      String key = String.valueOf(sessionCount);

      Session aSession = (Session) sessionTable.get(key);
      
      if(aSession!=null)
      {
         aSession.startSession(aPlayer);
         ret = new String(sessionId+"B");

      }// end of if

      if(DEBUG)
      {
          System.out.println(" in joinSession() ");
          System.out.println(aPlayer.getName()+" joined the Session "+sessionId);
      }

      return ret;

   }// end of postInvitation() 

   /**
   */
   public SessionInterface
   getSessionWithId(int sessionId) throws java.rmi.RemoteException
   {
      String key = String.valueOf(sessionCount);

      return (Session) sessionTable.get(key);

   }// end of getSessionWithId()

}// end of SessionManager

